<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TelemetricDataSelection_V3 StructType
 * @subpackage Structs
 */
class TelemetricDataSelection_V3 extends AbstractStructBase
{
    /**
     * The IncludeReverseGeocoding
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IncludeReverseGeocoding;
    /**
     * The Vehicles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Vehicles;
    /**
     * The Trailers
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Trailers;
    /**
     * The DateStrategySelection
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateStrategySelection
     */
    public $DateStrategySelection;
    /**
     * The AdditionalParameters
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $AdditionalParameters;
    /**
     * Constructor method for TelemetricDataSelection_V3
     * @uses TelemetricDataSelection_V3::setIncludeReverseGeocoding()
     * @uses TelemetricDataSelection_V3::setVehicles()
     * @uses TelemetricDataSelection_V3::setTrailers()
     * @uses TelemetricDataSelection_V3::setDateStrategySelection()
     * @uses TelemetricDataSelection_V3::setAdditionalParameters()
     * @param bool $includeReverseGeocoding
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @param \ArrayType\ArrayOfIdentifierVehicle $trailers
     * @param \StructType\DateStrategySelection $dateStrategySelection
     * @param \ArrayType\ArrayOfString $additionalParameters
     */
    public function __construct($includeReverseGeocoding = null, \ArrayType\ArrayOfIdentifierVehicle $vehicles = null, \ArrayType\ArrayOfIdentifierVehicle $trailers = null, \StructType\DateStrategySelection $dateStrategySelection = null, \ArrayType\ArrayOfString $additionalParameters = null)
    {
        $this
            ->setIncludeReverseGeocoding($includeReverseGeocoding)
            ->setVehicles($vehicles)
            ->setTrailers($trailers)
            ->setDateStrategySelection($dateStrategySelection)
            ->setAdditionalParameters($additionalParameters);
    }
    /**
     * Get IncludeReverseGeocoding value
     * @return bool
     */
    public function getIncludeReverseGeocoding()
    {
        return $this->IncludeReverseGeocoding;
    }
    /**
     * Set IncludeReverseGeocoding value
     * @param bool $includeReverseGeocoding
     * @return \StructType\TelemetricDataSelection_V3
     */
    public function setIncludeReverseGeocoding($includeReverseGeocoding = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeReverseGeocoding) && !is_bool($includeReverseGeocoding)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($includeReverseGeocoding, true), gettype($includeReverseGeocoding)), __LINE__);
        }
        $this->IncludeReverseGeocoding = $includeReverseGeocoding;
        return $this;
    }
    /**
     * Get Vehicles value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getVehicles()
    {
        return $this->Vehicles;
    }
    /**
     * Set Vehicles value
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @return \StructType\TelemetricDataSelection_V3
     */
    public function setVehicles(\ArrayType\ArrayOfIdentifierVehicle $vehicles = null)
    {
        $this->Vehicles = $vehicles;
        return $this;
    }
    /**
     * Get Trailers value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getTrailers()
    {
        return $this->Trailers;
    }
    /**
     * Set Trailers value
     * @param \ArrayType\ArrayOfIdentifierVehicle $trailers
     * @return \StructType\TelemetricDataSelection_V3
     */
    public function setTrailers(\ArrayType\ArrayOfIdentifierVehicle $trailers = null)
    {
        $this->Trailers = $trailers;
        return $this;
    }
    /**
     * Get DateStrategySelection value
     * @return \StructType\DateStrategySelection|null
     */
    public function getDateStrategySelection()
    {
        return $this->DateStrategySelection;
    }
    /**
     * Set DateStrategySelection value
     * @param \StructType\DateStrategySelection $dateStrategySelection
     * @return \StructType\TelemetricDataSelection_V3
     */
    public function setDateStrategySelection(\StructType\DateStrategySelection $dateStrategySelection = null)
    {
        $this->DateStrategySelection = $dateStrategySelection;
        return $this;
    }
    /**
     * Get AdditionalParameters value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getAdditionalParameters()
    {
        return $this->AdditionalParameters;
    }
    /**
     * Set AdditionalParameters value
     * @param \ArrayType\ArrayOfString $additionalParameters
     * @return \StructType\TelemetricDataSelection_V3
     */
    public function setAdditionalParameters(\ArrayType\ArrayOfString $additionalParameters = null)
    {
        $this->AdditionalParameters = $additionalParameters;
        return $this;
    }
}
